VERSION 5.00
Object = "{0A77CCF5-052C-11D6-B0EC-00B0D074179C}#1.0#0"; "Tws.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3225
   ClientLeft      =   60
   ClientTop       =   315
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3225
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox ProcessingTime 
      Alignment       =   1  'Right Justify
      Height          =   375
      Left            =   2160
      TabIndex        =   0
      Text            =   "0"
      Top             =   2040
      Width           =   735
   End
   Begin VB.CommandButton StopButton 
      Caption         =   "Stop"
      Height          =   495
      Left            =   3360
      TabIndex        =   2
      Top             =   2640
      Width           =   1215
   End
   Begin VB.CommandButton StartButton 
      Caption         =   "Start"
      Height          =   495
      Left            =   3360
      TabIndex        =   1
      Top             =   2040
      Width           =   1215
   End
   Begin TWSLib.Tws Tws1 
      Height          =   375
      Left            =   600
      TabIndex        =   3
      Top             =   480
      Width           =   3255
      _Version        =   65536
      _ExtentX        =   5741
      _ExtentY        =   661
      _StockProps     =   0
   End
   Begin VB.Label Label1 
      Caption         =   "Processing time (secs)"
      Height          =   255
      Left            =   360
      TabIndex        =   5
      Top             =   2040
      Width           =   1695
   End
   Begin VB.Label OutputLabel 
      Height          =   375
      Left            =   480
      TabIndex        =   4
      Top             =   1320
      Width           =   3855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' change these constants as required for your setup
Private Const Server As String = "DELPHI"   ' change this to the name of the computer running TWS
Private Const Port As Long = 7496
Private Const Symbol As String = "ES"
Private Const Expiry = "200409"
Private Const Exchange As String = "GLOBEX"
Private Const SecType As String = "FUT"
Private Const CurrencyCode As String = "USD"

Private lasttimer As Long

Private mTS As TextStream

Private Sub StartButton_Click()
Dim fs As FileSystemObject

StartButton.Enabled = False
StopButton.Enabled = True
Set fs = New FileSystemObject
If ProcessingTime > 0 Then
    Set mTS = fs.CreateTextFile(App.Path & "\TWSActiveXTest(" & ProcessingTime & ").log", True)
Else
    Set mTS = fs.CreateTextFile(App.Path & "\TWSActiveXTest(0).log", True)
End If

Randomize
Tws1.Connect Server, Port, CLng(1000000 * Rnd)
Tws1.reqMktData 1, Symbol, SecType, Expiry, 0#, "", Exchange, CurrencyCode
End Sub

Private Sub StopButton_Click()
Tws1.cancelMktData 1
Tws1.disconnect
StartButton.Enabled = True
StopButton.Enabled = False
OutputLabel.Caption = ""
End Sub

Private Sub Tws1_tickPrice(ByVal id As Long, ByVal tickType As Long, ByVal price As Double)
OutputLabel.Caption = "Type=" & tickType & "; price=" & Format(price, "0.00")
mTS.WriteLine Now & "  Ticktype=" & tickType & ", price=" & price
If Int(Timer) <> lasttimer And lasttimer <> 0 Then
    lasttimer = Int(Timer)
    Do While Int(Timer) < (lasttimer + ProcessingTime)
    Loop
End If
lasttimer = Int(Timer)
End Sub

Private Sub Tws1_tickSize(ByVal id As Long, ByVal tickType As Long, ByVal size As Long)
OutputLabel.Caption = "Type=" & tickType & "; size=" & size
mTS.WriteLine Now & "  Ticktype=" & tickType & ", size=" & size
If Int(Timer) <> lasttimer And lasttimer <> 0 Then
    lasttimer = Int(Timer)
    Do While Int(Timer) < (lasttimer + ProcessingTime)
    Loop
End If
lasttimer = Int(Timer)
End Sub

